news/urls.py
from django.urls import path

from . import views

app_name = "news"
urlpatterns = [
    path("", views.NewsListView.as_view(), name="news_list"),
    path("<int:pk>/", views.NewsDetailView.as_view(), name="news_detail"),
]

unchained/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path
from django.views.generic import RedirectView, TemplateView

from wrinklypages import views as wpviews

from . import views

urlpatterns = [
    path("", RedirectView.as_view(pattern_name="home")),
    path("home/", views.index, name="home"),
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path("admin/", admin.site.urls),
    path("activiteiten/", include("activities.urls")),
    path("service/docuweb/", include("docuweb.urls")),
    path("pages/", include("django.contrib.flatpages.urls")),
    path("leden/", include("members.urls")),
    path("vereniging/nieuws/", include("news.urls")),
    path("accounts/", include("authentication.urls")),
    path("vereniging/commissies/", include("groups.urls")),
    path("achievements/", include("achievements.urls")),
    path("i18n/", include("django.conf.urls.i18n")),
    path("ideal/", include("ideal.urls")),
    path("carriere/", include("career.urls")),
    path("publisher/", include("wrinklypages.urls")),
    path("tinymce/", include("tinymce.urls")),
    path("__debug__/", include("debug_toolbar.urls")),
] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

news/models.py
from datetime import datetime
from typing import Dict

from django.db import models
from django.db.models import F, Q
from django.db.models.constraints import CheckConstraint
from django.utils.translation import gettext_lazy as _
from tinymce.models import HTMLField

from unchained.junk_drawer import enum_field


class NewsMessage(models.Model):
    """A news message for on the homepage."""

    class Target(models.IntegerChoices):
        EVERYONE = 0, _("Iedereen")
        MEMBERS = 1, _("Leden")
        ACTIVE = 2, _("Actief")

    class Priority(models.IntegerChoices):
        HIGH = "2", _("Hoog")
        MEDIUM = "1", _("Normaal")
        LOW = "0", _("Laag")

    title: str = models.CharField(max_length=1024)
    content: str = HTMLField()

    target: str = models.IntegerField(choices=Target.choices, default=Target.EVERYONE)
    priority: str = models.IntegerField(choices=Priority.choices, default=Priority.HIGH)

    start: datetime = models.DateTimeField()
    end: datetime = models.DateTimeField()

    class Meta:
        constraints = [
            CheckConstraint(check=Q(start__lte=F("end")), name="start_before_end")
        ]

    def __str__(self) -> str:
        return self.title

    @classmethod
    def getVisibleMessages(cls, user):
        """Returns the news messages the current user has access to."""
        if not user.has_perm("authentication.member"):
            access = 0
        elif not user.has_perm("authentication.active"):
            access = 1
        else:
            access = 2
        return cls.objects.filter(target__lte=access)

news/views.py
from django.contrib.auth.mixins import PermissionRequiredMixin
from django.utils import timezone
from django.views import generic

from .models import NewsMessage


class NewsListView(generic.ListView):
    paginate_by = 10
    model = NewsMessage

    template_name = "news/news_list.html"
    context_object_name = "news_list"

    def get_queryset(self):
        return (
            NewsMessage.getVisibleMessages(self.request.user)
            .filter(start__lte=timezone.now())
            .order_by("-end")
        )


class NewsDetailView(PermissionRequiredMixin, generic.DetailView):
    model = NewsMessage

    template_name = "news/news_detail.html"
    context_object_name = "news"

    def get_permission_required(self):
        target = self.get_object().target
        if target == 2:
            return ["authentication.active"]
        elif target == 1:
            return ["authentication.member"]
        else:
            return []


# Returns the context containing the news messages for the home page.
def getNewsContext(request):
    context = {
        "news_list": NewsMessage.getVisibleMessages(request.user)
        .filter(start__lte=timezone.now(), end__gte=timezone.now())
        .order_by("-priority", "-start")
    }
    return context

news/templates/news/news_block.html
{% load i18n %}
<div class="box is-inline-block">
<h1 class="title">{% trans "Nieuws"%}</h1>
<table class="table is-striped is-bordered">
    <tbody>
        {% for news in news_list %}
            <tr>
                <td>
                    {% if perms.news.change_newsmessage %}
                        <a href="{% url 'news:news_detail' news.id %}"><h2 class="title">{{news.title}}</h2></a>
                    {% else %}
                        <h2 class="title">{{news.title}}</h2>
                    {% endif %}
                    <div class='content'>
                        {{news.content |safe}}
                    </div>
                </td>
            </tr>
        {% endfor %}
    </tbody>
</table>
</div>

news/templates/news/news_detail.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}
    {{ news.title }}
{% endblock %}

{% block body %}
    <h1 class="title"> 
        {{ news.title }} 
    </h1>
    <div class="box">
        {{news.content}}
    </div>

    <table class="table">
        <tbody>
            <tr>
                <th>{% trans "Doelgroep"%}</th>
                <td>{{news.get_target_display}}</td>
            </tr>
            <tr>
                <th>{% trans "Prioriteit"%}</th>
                <td>{{news.get_priority_display}}</td>
            </tr>
            <tr>
                <th>{% trans "Begindatum"%}</th>
                <td>{{news.start}}</td>
            </tr>
            <tr>
                <th>{% trans "Einddatum"%}</th>
                <td>{{news.end}}</td>
            </tr>
        </tbody>
    </table>

{% endblock %}

news/templates/news/news_list.html
{% extends "base.html" %}
{% load i18n %}

{% block title %}
    {% trans "Nieuws" %}
{% endblock %}

{% block body %}
    <h1 class="title">{% trans "Nieuws" %}</h1>
    <h2 class="subtitle">{% trans "Zoek hier een nieuwsbericht" %}</h1>

    <table class="table is-fullwidth is-striped">
        <thead>
            <tr>
                <td>
                    {% trans "Titel" %}
                </td>
                <td>
                    {% trans "Doelgroep" %}
                </td>
                <td>
                    {% trans "Prioriteit" %}
                </td>
                <td>
                    {% trans "Begindatum" %}
                </td>
                <td>
                    {% trans "Einddatum" %}
                </td>
            </tr>
        </thead>
        <tbody>
            {% for news in news_list %}
                <tr>
                    <td>
                        <a href="{% url 'news:news_detail' news.id %}">{{news.title}}</a>
                    </td>
                    <td>
                        {{news.get_target_display}}
                    </td>
                    <td>
                        {{news.get_priority_display}}
                    </td>
                    <td>
                        {{news.start}}
                    </td>
                    <td>
                        {{news.end}}
                    </td>
                </tr>
            {% endfor %}
        </tbody>
    </table>

    {% include "components/pagination.html"%}
{% endblock %}